--[[
Title: Hangman's Zoo
Author: Carl Reed - Captain Maelstrom
Date: 3-4-13
Purpose: Practice making something small, but more complex than Pong.
]]

require 'scripts/aliases'
require 'scripts/input'

function love.load()
	
	hangpng = newImage('hang.png')
	
	iterator = love.filesystem.lines('scripts/list.lua')	--pick a animal name, put it in the 'word' variable
	wordList = {}
	for line in iterator do
	table.insert(wordList, line)
	end
	
	word = wordList[round(185*math.random())]
	word = string.upper(word)
	wordLength = string.len(word)
	guess = ''
	guessed = {}
	guessed.wrong = {}
	timer = 0
	errors = 0
	occurences = {}
	lastScore = 0
	
end

function love.update(dt)

	mx = love.mouse.getX()
	my = love.mouse.getY()

	timer = timer+dt
	
	for i = 1, #alphabet do 	-- if user presses a letter key, put that letter in the text field
		if _G['key' .. string.upper(alphabet[i])] then guess = string.upper(alphabet[i]) end
		if backspace then guess = '' end
		for j, k in pairs(guessed) do
			if guess == k then guess = '' end
		end
	end
	
	if enter and guess ~= '' and errors < 6 then
		table.insert(guessed, guess)
		for i = 1, wordLength do
			local c = word:sub(i, i)
			if c == guess then table.insert(occurences, i) end
		end
		if #occurences == lastScore then
		errors = errors+1
		table.insert(guessed.wrong, guess)
		end
		guess = ''
		lastScore = #occurences
	end
	
	if errors == 6 and timer > 3.1 then
	timer = 0
	for i = 1, wordLength do
		occurences[i] = i
	end
	end
	if errors == 6 and timer > 3 then
	word = wordList[round(185*math.random())]
	word = string.upper(word)
	wordLength = string.len(word)
	guess = ''
	guessed = {}
	guessed.wrong = {}
	timer = 0
	errors = 0
	occurences = {}
	lastScore = 0
	end
	
	if #occurences == wordLength and timer > 3.1 then
	timer = 0
	end
	if #occurences == wordLength and timer > 3 then
	word = wordList[round(185*math.random())]
	word = string.upper(word)
	wordLength = string.len(word)
	guess = ''
	guessed = {}
	guessed.wrong = {}
	timer = 0
	errors = 0
	occurences = {}
	lastScore = 0
	end
	
end

function love.draw()

	setFont(font36)
	draw(hangpng, 375, 155)	-- draw man then cover his rope and him up
	clr(0,0,0)
	rect('fill', 395, 150, 10, 50)
	rect('fill', 375, 205 + (145/6)*errors, hangpng:getWidth(), 145 - (145/6)*errors) --and slowly uncover him top to bottom (not like that, you perv)
	
	clr(255,255,255)
	for j = 1, wordLength do	--draw bars for each letter in the word, then draw the rightly guessed words on top (if there are any yet)
		rect('fill' , (sw/2 - 50 - 50*(wordLength/2) +50*j), 500, 40, 2)
	end
	if #occurences ~= 0 then
	for i = 1, #occurences do
		p(word:sub(occurences[i],occurences[i]), sw/2 - 44 -50*(wordLength/2) + 50*occurences[i], 460)
	end
	end
	
	clr(255,255,255)
	rect('fill', sw/2-25, 350, 50, 5)	--draw gallows
	rect('fill', sw/2-25, 350, 5, 35)
	rect('fill', sw/2+20, 350,  5, 35)
	rect('fill',  200,  200, 235, 5)
	rect('fill',   225, 200,  5, 180)
	rect('fill',    175 , 380, 100, 5)
	
	if guessed.wrong ~= nil then	--make a list in the top right hand corner of wrong guesses, striked out
	for i, j in pairs(guessed.wrong) do
		p(j, 750, 44*i)
		rect('fill', 745, 44*i+22, 36, 2)
	end
	end
	
	p('GUESS:', 55,140)		--draw text entry field
	if timer%2 < 1 and guess == '' then rect('fill', 202, 146, 2, 32) end
	if timer%2 < 1 and guess ~= '' then rect('fill', 238, 146, 2, 32) end
	p(guess, 202,140)
	
	if errors == 6 then p('INCORRECT', 200, 550) end				--drawn if you win/lose
	if #occurences == wordLength and errors < 6 then p('CORRECT', 200, 550) end
	
end




